


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/crypto.py: 82%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/crypto.py</b> :
            <span class="pc_cov">82%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            156 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">127 run</span>
            <span class="mis shortkey_m button_toggle_mis">29 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">2 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm mis"><a href="#n24">24</a></p>
<p id="n25" class="stm mis"><a href="#n25">25</a></p>
<p id="n26" class="stm mis"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm run hide_run"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="pln"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="pln"><a href="#n38">38</a></p>
<p id="n39" class="pln"><a href="#n39">39</a></p>
<p id="n40" class="pln"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="stm run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="stm run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="stm run hide_run"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="stm run hide_run"><a href="#n65">65</a></p>
<p id="n66" class="stm run hide_run"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm run hide_run"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="stm run hide_run"><a href="#n71">71</a></p>
<p id="n72" class="stm run hide_run"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="stm run hide_run"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="stm run hide_run"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm run hide_run"><a href="#n84">84</a></p>
<p id="n85" class="stm run hide_run"><a href="#n85">85</a></p>
<p id="n86" class="pln"><a href="#n86">86</a></p>
<p id="n87" class="stm run hide_run"><a href="#n87">87</a></p>
<p id="n88" class="stm run hide_run"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="stm run hide_run"><a href="#n91">91</a></p>
<p id="n92" class="stm run hide_run"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="stm run hide_run"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="pln"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="pln"><a href="#n102">102</a></p>
<p id="n103" class="pln"><a href="#n103">103</a></p>
<p id="n104" class="pln"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="pln"><a href="#n108">108</a></p>
<p id="n109" class="pln"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="pln"><a href="#n114">114</a></p>
<p id="n115" class="pln"><a href="#n115">115</a></p>
<p id="n116" class="pln"><a href="#n116">116</a></p>
<p id="n117" class="pln"><a href="#n117">117</a></p>
<p id="n118" class="pln"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="pln"><a href="#n120">120</a></p>
<p id="n121" class="pln"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="pln"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="pln"><a href="#n125">125</a></p>
<p id="n126" class="pln"><a href="#n126">126</a></p>
<p id="n127" class="pln"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="pln"><a href="#n130">130</a></p>
<p id="n131" class="pln"><a href="#n131">131</a></p>
<p id="n132" class="pln"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="pln"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="pln"><a href="#n136">136</a></p>
<p id="n137" class="pln"><a href="#n137">137</a></p>
<p id="n138" class="pln"><a href="#n138">138</a></p>
<p id="n139" class="pln"><a href="#n139">139</a></p>
<p id="n140" class="pln"><a href="#n140">140</a></p>
<p id="n141" class="stm run hide_run"><a href="#n141">141</a></p>
<p id="n142" class="stm run hide_run"><a href="#n142">142</a></p>
<p id="n143" class="pln"><a href="#n143">143</a></p>
<p id="n144" class="stm run hide_run"><a href="#n144">144</a></p>
<p id="n145" class="stm run hide_run"><a href="#n145">145</a></p>
<p id="n146" class="stm run hide_run"><a href="#n146">146</a></p>
<p id="n147" class="stm run hide_run"><a href="#n147">147</a></p>
<p id="n148" class="pln"><a href="#n148">148</a></p>
<p id="n149" class="stm run hide_run"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>
<p id="n151" class="stm run hide_run"><a href="#n151">151</a></p>
<p id="n152" class="pln"><a href="#n152">152</a></p>
<p id="n153" class="stm run hide_run"><a href="#n153">153</a></p>
<p id="n154" class="stm run hide_run"><a href="#n154">154</a></p>
<p id="n155" class="pln"><a href="#n155">155</a></p>
<p id="n156" class="stm run hide_run"><a href="#n156">156</a></p>
<p id="n157" class="stm run hide_run"><a href="#n157">157</a></p>
<p id="n158" class="pln"><a href="#n158">158</a></p>
<p id="n159" class="stm run hide_run"><a href="#n159">159</a></p>
<p id="n160" class="stm run hide_run"><a href="#n160">160</a></p>
<p id="n161" class="stm run hide_run"><a href="#n161">161</a></p>
<p id="n162" class="pln"><a href="#n162">162</a></p>
<p id="n163" class="stm run hide_run"><a href="#n163">163</a></p>
<p id="n164" class="pln"><a href="#n164">164</a></p>
<p id="n165" class="stm run hide_run"><a href="#n165">165</a></p>
<p id="n166" class="stm run hide_run"><a href="#n166">166</a></p>
<p id="n167" class="stm run hide_run"><a href="#n167">167</a></p>
<p id="n168" class="stm run hide_run"><a href="#n168">168</a></p>
<p id="n169" class="stm run hide_run"><a href="#n169">169</a></p>
<p id="n170" class="stm run hide_run"><a href="#n170">170</a></p>
<p id="n171" class="stm run hide_run"><a href="#n171">171</a></p>
<p id="n172" class="pln"><a href="#n172">172</a></p>
<p id="n173" class="stm run hide_run"><a href="#n173">173</a></p>
<p id="n174" class="pln"><a href="#n174">174</a></p>
<p id="n175" class="stm run hide_run"><a href="#n175">175</a></p>
<p id="n176" class="pln"><a href="#n176">176</a></p>
<p id="n177" class="pln"><a href="#n177">177</a></p>
<p id="n178" class="pln"><a href="#n178">178</a></p>
<p id="n179" class="pln"><a href="#n179">179</a></p>
<p id="n180" class="pln"><a href="#n180">180</a></p>
<p id="n181" class="pln"><a href="#n181">181</a></p>
<p id="n182" class="pln"><a href="#n182">182</a></p>
<p id="n183" class="pln"><a href="#n183">183</a></p>
<p id="n184" class="pln"><a href="#n184">184</a></p>
<p id="n185" class="pln"><a href="#n185">185</a></p>
<p id="n186" class="pln"><a href="#n186">186</a></p>
<p id="n187" class="pln"><a href="#n187">187</a></p>
<p id="n188" class="pln"><a href="#n188">188</a></p>
<p id="n189" class="pln"><a href="#n189">189</a></p>
<p id="n190" class="pln"><a href="#n190">190</a></p>
<p id="n191" class="pln"><a href="#n191">191</a></p>
<p id="n192" class="pln"><a href="#n192">192</a></p>
<p id="n193" class="pln"><a href="#n193">193</a></p>
<p id="n194" class="pln"><a href="#n194">194</a></p>
<p id="n195" class="pln"><a href="#n195">195</a></p>
<p id="n196" class="pln"><a href="#n196">196</a></p>
<p id="n197" class="pln"><a href="#n197">197</a></p>
<p id="n198" class="stm run hide_run"><a href="#n198">198</a></p>
<p id="n199" class="stm run hide_run"><a href="#n199">199</a></p>
<p id="n200" class="pln"><a href="#n200">200</a></p>
<p id="n201" class="stm run hide_run"><a href="#n201">201</a></p>
<p id="n202" class="pln"><a href="#n202">202</a></p>
<p id="n203" class="stm run hide_run"><a href="#n203">203</a></p>
<p id="n204" class="pln"><a href="#n204">204</a></p>
<p id="n205" class="stm run hide_run"><a href="#n205">205</a></p>
<p id="n206" class="pln"><a href="#n206">206</a></p>
<p id="n207" class="stm run hide_run"><a href="#n207">207</a></p>
<p id="n208" class="pln"><a href="#n208">208</a></p>
<p id="n209" class="pln"><a href="#n209">209</a></p>
<p id="n210" class="pln"><a href="#n210">210</a></p>
<p id="n211" class="pln"><a href="#n211">211</a></p>
<p id="n212" class="pln"><a href="#n212">212</a></p>
<p id="n213" class="pln"><a href="#n213">213</a></p>
<p id="n214" class="pln"><a href="#n214">214</a></p>
<p id="n215" class="pln"><a href="#n215">215</a></p>
<p id="n216" class="pln"><a href="#n216">216</a></p>
<p id="n217" class="pln"><a href="#n217">217</a></p>
<p id="n218" class="pln"><a href="#n218">218</a></p>
<p id="n219" class="pln"><a href="#n219">219</a></p>
<p id="n220" class="pln"><a href="#n220">220</a></p>
<p id="n221" class="pln"><a href="#n221">221</a></p>
<p id="n222" class="stm run hide_run"><a href="#n222">222</a></p>
<p id="n223" class="stm run hide_run"><a href="#n223">223</a></p>
<p id="n224" class="pln"><a href="#n224">224</a></p>
<p id="n225" class="stm run hide_run"><a href="#n225">225</a></p>
<p id="n226" class="pln"><a href="#n226">226</a></p>
<p id="n227" class="stm par run hide_run"><a href="#n227">227</a></p>
<p id="n228" class="stm run hide_run"><a href="#n228">228</a></p>
<p id="n229" class="pln"><a href="#n229">229</a></p>
<p id="n230" class="stm par run hide_run"><a href="#n230">230</a></p>
<p id="n231" class="stm mis"><a href="#n231">231</a></p>
<p id="n232" class="pln"><a href="#n232">232</a></p>
<p id="n233" class="stm run hide_run"><a href="#n233">233</a></p>
<p id="n234" class="stm run hide_run"><a href="#n234">234</a></p>
<p id="n235" class="pln"><a href="#n235">235</a></p>
<p id="n236" class="stm run hide_run"><a href="#n236">236</a></p>
<p id="n237" class="stm run hide_run"><a href="#n237">237</a></p>
<p id="n238" class="stm run hide_run"><a href="#n238">238</a></p>
<p id="n239" class="stm run hide_run"><a href="#n239">239</a></p>
<p id="n240" class="pln"><a href="#n240">240</a></p>
<p id="n241" class="stm run hide_run"><a href="#n241">241</a></p>
<p id="n242" class="pln"><a href="#n242">242</a></p>
<p id="n243" class="pln"><a href="#n243">243</a></p>
<p id="n244" class="stm run hide_run"><a href="#n244">244</a></p>
<p id="n245" class="stm run hide_run"><a href="#n245">245</a></p>
<p id="n246" class="pln"><a href="#n246">246</a></p>
<p id="n247" class="pln"><a href="#n247">247</a></p>
<p id="n248" class="pln"><a href="#n248">248</a></p>
<p id="n249" class="pln"><a href="#n249">249</a></p>
<p id="n250" class="pln"><a href="#n250">250</a></p>
<p id="n251" class="pln"><a href="#n251">251</a></p>
<p id="n252" class="pln"><a href="#n252">252</a></p>
<p id="n253" class="stm run hide_run"><a href="#n253">253</a></p>
<p id="n254" class="pln"><a href="#n254">254</a></p>
<p id="n255" class="stm run hide_run"><a href="#n255">255</a></p>
<p id="n256" class="stm run hide_run"><a href="#n256">256</a></p>
<p id="n257" class="stm run hide_run"><a href="#n257">257</a></p>
<p id="n258" class="stm run hide_run"><a href="#n258">258</a></p>
<p id="n259" class="stm run hide_run"><a href="#n259">259</a></p>
<p id="n260" class="stm run hide_run"><a href="#n260">260</a></p>
<p id="n261" class="stm run hide_run"><a href="#n261">261</a></p>
<p id="n262" class="stm run hide_run"><a href="#n262">262</a></p>
<p id="n263" class="stm run hide_run"><a href="#n263">263</a></p>
<p id="n264" class="pln"><a href="#n264">264</a></p>
<p id="n265" class="stm run hide_run"><a href="#n265">265</a></p>
<p id="n266" class="stm run hide_run"><a href="#n266">266</a></p>
<p id="n267" class="pln"><a href="#n267">267</a></p>
<p id="n268" class="stm run hide_run"><a href="#n268">268</a></p>
<p id="n269" class="pln"><a href="#n269">269</a></p>
<p id="n270" class="stm run hide_run"><a href="#n270">270</a></p>
<p id="n271" class="pln"><a href="#n271">271</a></p>
<p id="n272" class="stm mis"><a href="#n272">272</a></p>
<p id="n273" class="stm mis"><a href="#n273">273</a></p>
<p id="n274" class="stm mis"><a href="#n274">274</a></p>
<p id="n275" class="stm mis"><a href="#n275">275</a></p>
<p id="n276" class="stm mis"><a href="#n276">276</a></p>
<p id="n277" class="stm mis"><a href="#n277">277</a></p>
<p id="n278" class="stm mis"><a href="#n278">278</a></p>
<p id="n279" class="stm mis"><a href="#n279">279</a></p>
<p id="n280" class="stm mis"><a href="#n280">280</a></p>
<p id="n281" class="stm mis"><a href="#n281">281</a></p>
<p id="n282" class="pln"><a href="#n282">282</a></p>
<p id="n283" class="stm mis"><a href="#n283">283</a></p>
<p id="n284" class="stm mis"><a href="#n284">284</a></p>
<p id="n285" class="pln"><a href="#n285">285</a></p>
<p id="n286" class="stm mis"><a href="#n286">286</a></p>
<p id="n287" class="stm mis"><a href="#n287">287</a></p>
<p id="n288" class="pln"><a href="#n288">288</a></p>
<p id="n289" class="stm run hide_run"><a href="#n289">289</a></p>
<p id="n290" class="pln"><a href="#n290">290</a></p>
<p id="n291" class="stm run hide_run"><a href="#n291">291</a></p>
<p id="n292" class="stm run hide_run"><a href="#n292">292</a></p>
<p id="n293" class="stm run hide_run"><a href="#n293">293</a></p>
<p id="n294" class="stm run hide_run"><a href="#n294">294</a></p>
<p id="n295" class="stm run hide_run"><a href="#n295">295</a></p>
<p id="n296" class="stm run hide_run"><a href="#n296">296</a></p>
<p id="n297" class="stm run hide_run"><a href="#n297">297</a></p>
<p id="n298" class="stm run hide_run"><a href="#n298">298</a></p>
<p id="n299" class="stm run hide_run"><a href="#n299">299</a></p>
<p id="n300" class="stm run hide_run"><a href="#n300">300</a></p>
<p id="n301" class="stm run hide_run"><a href="#n301">301</a></p>
<p id="n302" class="stm run hide_run"><a href="#n302">302</a></p>
<p id="n303" class="stm run hide_run"><a href="#n303">303</a></p>
<p id="n304" class="stm run hide_run"><a href="#n304">304</a></p>
<p id="n305" class="stm run hide_run"><a href="#n305">305</a></p>
<p id="n306" class="pln"><a href="#n306">306</a></p>
<p id="n307" class="stm run hide_run"><a href="#n307">307</a></p>
<p id="n308" class="stm run hide_run"><a href="#n308">308</a></p>
<p id="n309" class="pln"><a href="#n309">309</a></p>
<p id="n310" class="stm run hide_run"><a href="#n310">310</a></p>
<p id="n311" class="pln"><a href="#n311">311</a></p>
<p id="n312" class="stm run hide_run"><a href="#n312">312</a></p>
<p id="n313" class="pln"><a href="#n313">313</a></p>
<p id="n314" class="stm mis"><a href="#n314">314</a></p>
<p id="n315" class="stm mis"><a href="#n315">315</a></p>
<p id="n316" class="pln"><a href="#n316">316</a></p>
<p id="n317" class="stm mis"><a href="#n317">317</a></p>
<p id="n318" class="stm mis"><a href="#n318">318</a></p>
<p id="n319" class="stm mis"><a href="#n319">319</a></p>
<p id="n320" class="stm mis"><a href="#n320">320</a></p>
<p id="n321" class="pln"><a href="#n321">321</a></p>
<p id="n322" class="stm mis"><a href="#n322">322</a></p>
<p id="n323" class="stm mis"><a href="#n323">323</a></p>
<p id="n324" class="pln"><a href="#n324">324</a></p>
<p id="n325" class="stm mis"><a href="#n325">325</a></p>
<p id="n326" class="stm mis"><a href="#n326">326</a></p>
<p id="n327" class="pln"><a href="#n327">327</a></p>
<p id="n328" class="stm mis"><a href="#n328">328</a></p>
<p id="n329" class="pln"><a href="#n329">329</a></p>
<p id="n330" class="stm run hide_run"><a href="#n330">330</a></p>
<p id="n331" class="pln"><a href="#n331">331</a></p>
<p id="n332" class="stm run hide_run"><a href="#n332">332</a></p>
<p id="n333" class="stm run hide_run"><a href="#n333">333</a></p>
<p id="n334" class="pln"><a href="#n334">334</a></p>
<p id="n335" class="stm run hide_run"><a href="#n335">335</a></p>
<p id="n336" class="stm run hide_run"><a href="#n336">336</a></p>
<p id="n337" class="stm run hide_run"><a href="#n337">337</a></p>
<p id="n338" class="stm run hide_run"><a href="#n338">338</a></p>
<p id="n339" class="pln"><a href="#n339">339</a></p>
<p id="n340" class="stm run hide_run"><a href="#n340">340</a></p>
<p id="n341" class="stm run hide_run"><a href="#n341">341</a></p>
<p id="n342" class="pln"><a href="#n342">342</a></p>
<p id="n343" class="stm run hide_run"><a href="#n343">343</a></p>
<p id="n344" class="stm run hide_run"><a href="#n344">344</a></p>
<p id="n345" class="pln"><a href="#n345">345</a></p>
<p id="n346" class="stm run hide_run"><a href="#n346">346</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Author: Alberto Solino (beto@coresecurity.com)</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#   RFC 4493 implementation (https://www.ietf.org/rfc/rfc4493.txt)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#   RFC 4615 implementation (https://www.ietf.org/rfc/rfc4615.txt)</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#   NIST SP 800-108 Section 5.1, with PRF HMAC-SHA256 implementation</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#   (https://tools.ietf.org/html/draft-irtf-cfrg-kdf-uses-00#ref-SP800-108)</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#   [MS-LSAD] Section 5.1.2</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com">#   [MS-SAMR] Section 2.2.11.1.1</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">division</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">print_function</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run"><span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run">    <span class="key">from</span> <span class="nam">Cryptodome</span><span class="op">.</span><span class="nam">Cipher</span> <span class="key">import</span> <span class="nam">DES</span><span class="op">,</span> <span class="nam">AES</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm mis"><span class="key">except</span> <span class="nam">Exception</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm mis">    <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"Warning: You don't have any crypto installed. You need pycryptodomex"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm mis">    <span class="nam">LOG</span><span class="op">.</span><span class="nam">error</span><span class="op">(</span><span class="str">"See https://pypi.org/project/pycryptodomex/"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">from</span> <span class="nam">struct</span> <span class="key">import</span> <span class="nam">pack</span><span class="op">,</span> <span class="nam">unpack</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">structure</span> <span class="key">import</span> <span class="nam">Structure</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run"><span class="key">import</span> <span class="nam">hmac</span><span class="op">,</span> <span class="nam">hashlib</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm run hide_run"><span class="key">from</span> <span class="nam">six</span> <span class="key">import</span> <span class="nam">b</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run"><span class="key">def</span> <span class="nam">Generate_Subkey</span><span class="op">(</span><span class="nam">K</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln"><span class="com">#   +                    Algorithm Generate_Subkey                      +</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="pln"><span class="com">#   +   Input    : K (128-bit key)                                      +</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="pln"><span class="com">#   +   Output   : K1 (128-bit first subkey)                            +</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="pln"><span class="com">#   +              K2 (128-bit second subkey)                           +</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln"><span class="com">#   +-------------------------------------------------------------------+</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln"><span class="com">#   +   Constants: const_Zero is 0x00000000000000000000000000000000     +</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="com">#   +              const_Rb   is 0x00000000000000000000000000000087     +</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln"><span class="com">#   +   Variables: L          for output of AES-128 applied to 0^128    +</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="com">#   +   Step 1.  L := AES-128(K, const_Zero);                           +</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="com">#   +   Step 2.  if MSB(L) is equal to 0                                +</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="com">#   +            then    K1 := L &lt;&lt; 1;                                  +</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln"><span class="com">#   +            else    K1 := (L &lt;&lt; 1) XOR const_Rb;                   +</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln"><span class="com">#   +   Step 3.  if MSB(K1) is equal to 0                               +</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="com">#   +            then    K2 := K1 &lt;&lt; 1;                                 +</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="com">#   +            else    K2 := (K1 &lt;&lt; 1) XOR const_Rb;                  +</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln"><span class="com">#   +   Step 4.  return K1, K2;                                         +</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm run hide_run">    <span class="nam">AES_128</span> <span class="op">=</span> <span class="nam">AES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">K</span><span class="op">,</span> <span class="nam">AES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run">    <span class="nam">L</span> <span class="op">=</span> <span class="nam">AES_128</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">bytes</span><span class="op">(</span><span class="nam">bytearray</span><span class="op">(</span><span class="num">16</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm run hide_run">    <span class="nam">LHigh</span> <span class="op">=</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">'>Q'</span><span class="op">,</span><span class="nam">L</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="stm run hide_run">    <span class="nam">LLow</span>  <span class="op">=</span> <span class="nam">unpack</span><span class="op">(</span><span class="str">'>Q'</span><span class="op">,</span><span class="nam">L</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm run hide_run">    <span class="nam">K1High</span> <span class="op">=</span> <span class="op">(</span><span class="op">(</span><span class="nam">LHigh</span> <span class="op">&lt;&lt;</span> <span class="num">1</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span> <span class="nam">LLow</span> <span class="op">>></span> <span class="num">63</span> <span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xFFFFFFFFFFFFFFFF</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm run hide_run">    <span class="nam">K1Low</span>  <span class="op">=</span> <span class="op">(</span><span class="nam">LLow</span> <span class="op">&lt;&lt;</span> <span class="num">1</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xFFFFFFFFFFFFFFFF</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run">    <span class="key">if</span> <span class="op">(</span><span class="nam">LHigh</span> <span class="op">>></span> <span class="num">63</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm run hide_run">        <span class="nam">K1Low</span> <span class="op">^=</span> <span class="num">0x87</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm run hide_run">    <span class="nam">K2High</span> <span class="op">=</span> <span class="op">(</span><span class="op">(</span><span class="nam">K1High</span> <span class="op">&lt;&lt;</span> <span class="num">1</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">K1Low</span> <span class="op">>></span> <span class="num">63</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xFFFFFFFFFFFFFFFF</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm run hide_run">    <span class="nam">K2Low</span>  <span class="op">=</span> <span class="op">(</span><span class="op">(</span><span class="nam">K1Low</span> <span class="op">&lt;&lt;</span> <span class="num">1</span><span class="op">)</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xFFFFFFFFFFFFFFFF</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">    <span class="key">if</span> <span class="op">(</span><span class="nam">K1High</span> <span class="op">>></span> <span class="num">63</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm run hide_run">        <span class="nam">K2Low</span> <span class="op">^=</span> <span class="num">0x87</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">    <span class="nam">K1</span> <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>QQ'</span><span class="op">,</span> <span class="nam">K1High</span><span class="op">,</span> <span class="nam">K1Low</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">    <span class="nam">K2</span> <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="nam">pack</span><span class="op">(</span><span class="str">'>QQ'</span><span class="op">,</span> <span class="nam">K2High</span><span class="op">,</span> <span class="nam">K2Low</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm run hide_run">    <span class="key">return</span> <span class="nam">K1</span><span class="op">,</span> <span class="nam">K2</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run"><span class="key">def</span> <span class="nam">XOR_128</span><span class="op">(</span><span class="nam">N1</span><span class="op">,</span><span class="nam">N2</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm run hide_run">    <span class="nam">J</span> <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm run hide_run">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">len</span><span class="op">(</span><span class="nam">N1</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="pln">        <span class="com">#J.append(indexbytes(N1,i) ^ indexbytes(N2,i))</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="stm run hide_run">        <span class="nam">J</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">N1</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span> <span class="op">^</span> <span class="nam">N2</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm run hide_run">    <span class="key">return</span> <span class="nam">J</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run"><span class="key">def</span> <span class="nam">PAD</span><span class="op">(</span><span class="nam">N</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="stm run hide_run">    <span class="nam">padLen</span> <span class="op">=</span> <span class="num">16</span><span class="op">-</span><span class="nam">len</span><span class="op">(</span><span class="nam">N</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="stm run hide_run">    <span class="key">return</span>  <span class="nam">N</span> <span class="op">+</span> <span class="str">b'\x80'</span> <span class="op">+</span> <span class="str">b'\x00'</span><span class="op">*</span><span class="op">(</span><span class="nam">padLen</span><span class="op">-</span><span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm run hide_run"><span class="key">def</span> <span class="nam">AES_CMAC</span><span class="op">(</span><span class="nam">K</span><span class="op">,</span> <span class="nam">M</span><span class="op">,</span> <span class="nam">length</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln"><span class="com">#   +                   Algorithm AES-CMAC                              +</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="com">#   +   Input    : K    ( 128-bit key )                                 +</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln"><span class="com">#   +            : M    ( message to be authenticated )                 +</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="pln"><span class="com">#   +            : len  ( length of the message in octets )             +</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="pln"><span class="com">#   +   Output   : T    ( message authentication code )                 +</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln"><span class="com">#   +   Constants: const_Zero is 0x00000000000000000000000000000000     +</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln"><span class="com">#   +              const_Bsize is 16                                    +</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="pln"><span class="com">#   +   Variables: K1, K2 for 128-bit subkeys                           +</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln"><span class="com">#   +              M_i is the i-th block (i=1..ceil(len/const_Bsize))   +</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln"><span class="com">#   +              M_last is the last block xor-ed with K1 or K2        +</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln"><span class="com">#   +              n      for number of blocks to be processed          +</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln"><span class="com">#   +              r      for number of octets of last block            +</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="pln"><span class="com">#   +              flag   for denoting if last block is complete or not +</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="pln"><span class="com">#   +   Step 1.  (K1,K2) := Generate_Subkey(K);                         +</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="pln"><span class="com">#   +   Step 2.  n := ceil(len/const_Bsize);                            +</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="pln"><span class="com">#   +   Step 3.  if n = 0                                               +</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln"><span class="com">#   +            then                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="pln"><span class="com">#   +                 n := 1;                                           +</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="pln"><span class="com">#   +                 flag := false;                                    +</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln"><span class="com">#   +            else                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="pln"><span class="com">#   +                 if len mod const_Bsize is 0                       +</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln"><span class="com">#   +                 then flag := true;                                +</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="pln"><span class="com">#   +                 else flag := false;                               +</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="pln"><span class="com">#   +   Step 4.  if flag is true                                        +</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln"><span class="com">#   +            then M_last := M_n XOR K1;                             +</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln"><span class="com">#   +            else M_last := padding(M_n) XOR K2;                    +</span><span class="strut">&nbsp;</span></p>
<p id="t130" class="pln"><span class="com">#   +   Step 5.  X := const_Zero;                                       +</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="pln"><span class="com">#   +   Step 6.  for i := 1 to n-1 do                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="pln"><span class="com">#   +                begin                                              +</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln"><span class="com">#   +                  Y := X XOR M_i;                                  +</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="pln"><span class="com">#   +                  X := AES-128(K,Y);                               +</span><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln"><span class="com">#   +                end                                                +</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="pln"><span class="com">#   +            Y := M_last XOR X;                                     +</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="pln"><span class="com">#   +            T := AES-128(K,Y);                                     +</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="pln"><span class="com">#   +   Step 7.  return T;                                              +</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm run hide_run">    <span class="nam">const_Bsize</span> <span class="op">=</span> <span class="num">16</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm run hide_run">    <span class="nam">const_Zero</span>  <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="num">16</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t144" class="stm run hide_run">    <span class="nam">AES_128</span><span class="op">=</span> <span class="nam">AES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">K</span><span class="op">,</span> <span class="nam">AES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="stm run hide_run">    <span class="nam">M</span>      <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="nam">M</span><span class="op">[</span><span class="op">:</span><span class="nam">length</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="stm run hide_run">    <span class="nam">K1</span><span class="op">,</span> <span class="nam">K2</span> <span class="op">=</span> <span class="nam">Generate_Subkey</span><span class="op">(</span><span class="nam">K</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t147" class="stm run hide_run">    <span class="nam">n</span>      <span class="op">=</span> <span class="nam">len</span><span class="op">(</span><span class="nam">M</span><span class="op">)</span><span class="op">//</span><span class="nam">const_Bsize</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm run hide_run">    <span class="key">if</span> <span class="nam">n</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">        <span class="nam">n</span> <span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="stm run hide_run">        <span class="nam">flag</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="pln">    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="stm run hide_run">        <span class="key">if</span> <span class="op">(</span><span class="nam">length</span> <span class="op">%</span> <span class="nam">const_Bsize</span><span class="op">)</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t154" class="stm run hide_run">            <span class="nam">flag</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="stm run hide_run">            <span class="nam">n</span> <span class="op">+=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="stm run hide_run">            <span class="nam">flag</span> <span class="op">=</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t159" class="stm run hide_run">    <span class="nam">M_n</span> <span class="op">=</span> <span class="nam">M</span><span class="op">[</span><span class="op">(</span><span class="nam">n</span><span class="op">-</span><span class="num">1</span><span class="op">)</span><span class="op">*</span><span class="nam">const_Bsize</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t160" class="stm run hide_run">    <span class="key">if</span> <span class="nam">flag</span> <span class="key">is</span> <span class="key">True</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="stm run hide_run">        <span class="nam">M_last</span> <span class="op">=</span> <span class="nam">XOR_128</span><span class="op">(</span><span class="nam">M_n</span><span class="op">,</span><span class="nam">K1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="pln">    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm run hide_run">        <span class="nam">M_last</span> <span class="op">=</span> <span class="nam">XOR_128</span><span class="op">(</span><span class="nam">PAD</span><span class="op">(</span><span class="nam">M_n</span><span class="op">)</span><span class="op">,</span><span class="nam">K2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t165" class="stm run hide_run">    <span class="nam">X</span> <span class="op">=</span> <span class="nam">const_Zero</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="stm run hide_run">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">-</span><span class="num">1</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="stm run hide_run">        <span class="nam">M_i</span> <span class="op">=</span> <span class="nam">M</span><span class="op">[</span><span class="op">(</span><span class="nam">i</span><span class="op">)</span><span class="op">*</span><span class="nam">const_Bsize</span><span class="op">:</span><span class="op">]</span><span class="op">[</span><span class="op">:</span><span class="num">16</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm run hide_run">        <span class="nam">Y</span>   <span class="op">=</span> <span class="nam">XOR_128</span><span class="op">(</span><span class="nam">X</span><span class="op">,</span> <span class="nam">M_i</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm run hide_run">        <span class="nam">X</span>   <span class="op">=</span> <span class="nam">bytearray</span><span class="op">(</span><span class="nam">AES_128</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">bytes</span><span class="op">(</span><span class="nam">Y</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="stm run hide_run">    <span class="nam">Y</span> <span class="op">=</span> <span class="nam">XOR_128</span><span class="op">(</span><span class="nam">M_last</span><span class="op">,</span> <span class="nam">X</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="stm run hide_run">    <span class="nam">T</span> <span class="op">=</span> <span class="nam">AES_128</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">bytes</span><span class="op">(</span><span class="nam">Y</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t173" class="stm run hide_run">    <span class="key">return</span> <span class="nam">T</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm run hide_run"><span class="key">def</span> <span class="nam">AES_CMAC_PRF_128</span><span class="op">(</span><span class="nam">VK</span><span class="op">,</span> <span class="nam">M</span><span class="op">,</span> <span class="nam">VKlen</span><span class="op">,</span> <span class="nam">Mlen</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="pln"><span class="com">#   +                        AES-CMAC-PRF-128                           +</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t180" class="pln"><span class="com">#   + Input  : VK (Variable-length key)                                 +</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="pln"><span class="com">#   +        : M (Message, i.e., the input data of the PRF)             +</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="pln"><span class="com">#   +        : VKlen (length of VK in octets)                           +</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="pln"><span class="com">#   +        : len (length of M in octets)                              +</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="pln"><span class="com">#   + Output : PRV (128-bit Pseudo-Random Variable)                     +</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t186" class="pln"><span class="com">#   +-------------------------------------------------------------------+</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="pln"><span class="com">#   + Variable: K (128-bit key for AES-CMAC)                            +</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="pln"><span class="com">#   + Step 1.   If VKlen is equal to 16                                 +</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="pln"><span class="com">#   + Step 1a.  then                                                    +</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="pln"><span class="com">#   +               K := VK;                                            +</span><span class="strut">&nbsp;</span></p>
<p id="t192" class="pln"><span class="com">#   + Step 1b.  else                                                    +</span><span class="strut">&nbsp;</span></p>
<p id="t193" class="pln"><span class="com">#   +               K := AES-CMAC(0^128, VK, VKlen);                    +</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="pln"><span class="com">#   + Step 2.   PRV := AES-CMAC(K, M, len);                             +</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="pln"><span class="com">#   +           return PRV;                                             +</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="pln"><span class="com">#   +                                                                   +</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="pln"><span class="com">#   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm run hide_run">    <span class="key">if</span> <span class="nam">VKlen</span> <span class="op">==</span> <span class="num">16</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm run hide_run">        <span class="nam">K</span> <span class="op">=</span> <span class="nam">VK</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="pln">    <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm run hide_run">        <span class="nam">K</span> <span class="op">=</span> <span class="nam">AES_CMAC</span><span class="op">(</span><span class="nam">bytes</span><span class="op">(</span><span class="nam">bytearray</span><span class="op">(</span><span class="num">16</span><span class="op">)</span><span class="op">)</span><span class="op">,</span> <span class="nam">VK</span><span class="op">,</span> <span class="nam">VKlen</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t203" class="stm run hide_run">    <span class="nam">PRV</span> <span class="op">=</span> <span class="nam">AES_CMAC</span><span class="op">(</span><span class="nam">K</span><span class="op">,</span> <span class="nam">M</span><span class="op">,</span> <span class="nam">Mlen</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t204" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t205" class="stm run hide_run">    <span class="key">return</span> <span class="nam">PRV</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t207" class="stm run hide_run"><span class="key">def</span> <span class="nam">KDF_CounterMode</span><span class="op">(</span><span class="nam">KI</span><span class="op">,</span> <span class="nam">Label</span><span class="op">,</span> <span class="nam">Context</span><span class="op">,</span> <span class="nam">L</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t208" class="pln"><span class="com"># Implements NIST SP 800-108 Section 5.1, with PRF HMAC-SHA256</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="pln"><span class="com"># https://tools.ietf.org/html/draft-irtf-cfrg-kdf-uses-00#ref-SP800-108</span><span class="strut">&nbsp;</span></p>
<p id="t210" class="pln"><span class="com"># Fixed values:</span><span class="strut">&nbsp;</span></p>
<p id="t211" class="pln"><span class="com">#  1. h - The length of the output of the PRF in bits, and</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="pln"><span class="com">#  2. r - The length of the binary representation of the counter i.</span><span class="strut">&nbsp;</span></p>
<p id="t213" class="pln"><span class="com"># Input: KI, Label, Context, and L.</span><span class="strut">&nbsp;</span></p>
<p id="t214" class="pln"><span class="com"># Process:</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="pln"><span class="com">#  1. n := [L/h]</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="pln"><span class="com">#  2. If n > 2r-1, then indicate an error and stop.</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="pln"><span class="com">#  3. result(0):= empty .</span><span class="strut">&nbsp;</span></p>
<p id="t218" class="pln"><span class="com">#  4. For i = 1 to n, do</span><span class="strut">&nbsp;</span></p>
<p id="t219" class="pln"><span class="com">#    a. K(i) := PRF (KI, [i]2 || Label || 0x00 || Context || [L]2)</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="pln"><span class="com">#    b. result(i) := result(i-1) || K(i).</span><span class="strut">&nbsp;</span></p>
<p id="t221" class="pln"><span class="com">#  5. Return: KO := the leftmost L bits of result(n).</span><span class="strut">&nbsp;</span></p>
<p id="t222" class="stm run hide_run">    <span class="nam">h</span> <span class="op">=</span> <span class="num">256</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm run hide_run">    <span class="nam">r</span> <span class="op">=</span> <span class="num">32</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm run hide_run">    <span class="nam">n</span> <span class="op">=</span> <span class="nam">L</span> <span class="op">//</span> <span class="nam">h</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm par run hide_run"><span class="annotate short">227&#x202F;&#x219B;&#x202F;230</span><span class="annotate long">line 227 didn't jump to line 230, because the condition on line 227 was never false</span>    <span class="key">if</span> <span class="nam">n</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="stm run hide_run">        <span class="nam">n</span> <span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t229" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm par run hide_run"><span class="annotate short">230&#x202F;&#x219B;&#x202F;231</span><span class="annotate long">line 230 didn't jump to line 231, because the condition on line 230 was never true</span>    <span class="key">if</span> <span class="nam">n</span> <span class="op">></span> <span class="op">(</span><span class="nam">pow</span><span class="op">(</span><span class="num">2</span><span class="op">,</span><span class="nam">r</span><span class="op">)</span><span class="op">-</span><span class="num">1</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="stm mis">        <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"Error computing KDF_CounterMode"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t233" class="stm run hide_run">    <span class="nam">result</span> <span class="op">=</span> <span class="str">b''</span><span class="strut">&nbsp;</span></p>
<p id="t234" class="stm run hide_run">    <span class="nam">K</span>      <span class="op">=</span> <span class="str">b''</span><span class="strut">&nbsp;</span></p>
<p id="t235" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t236" class="stm run hide_run">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">1</span><span class="op">,</span><span class="nam">n</span><span class="op">+</span><span class="num">1</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t237" class="stm run hide_run">       <span class="nam">input</span> <span class="op">=</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span> <span class="nam">i</span><span class="op">)</span> <span class="op">+</span> <span class="nam">Label</span> <span class="op">+</span> <span class="str">b'\x00'</span> <span class="op">+</span> <span class="nam">Context</span> <span class="op">+</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'>L'</span><span class="op">,</span><span class="nam">L</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t238" class="stm run hide_run">       <span class="nam">K</span> <span class="op">=</span> <span class="nam">hmac</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">KI</span><span class="op">,</span> <span class="nam">input</span><span class="op">,</span> <span class="nam">hashlib</span><span class="op">.</span><span class="nam">sha256</span><span class="op">)</span><span class="op">.</span><span class="nam">digest</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm run hide_run">       <span class="nam">result</span> <span class="op">=</span> <span class="nam">result</span> <span class="op">+</span> <span class="nam">K</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm run hide_run">    <span class="key">return</span> <span class="nam">result</span><span class="op">[</span><span class="op">:</span><span class="op">(</span><span class="nam">L</span><span class="op">//</span><span class="num">8</span><span class="op">)</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t243" class="pln"><span class="com"># [MS-LSAD] Section 5.1.2 / 5.1.3</span><span class="strut">&nbsp;</span></p>
<p id="t244" class="stm run hide_run"><span class="key">class</span> <span class="nam">LSA_SECRET_XP</span><span class="op">(</span><span class="nam">Structure</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t245" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t246" class="pln">        <span class="op">(</span><span class="str">'Length'</span><span class="op">,</span><span class="str">'&lt;L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t247" class="pln">        <span class="op">(</span><span class="str">'Version'</span><span class="op">,</span><span class="str">'&lt;L=0'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t248" class="pln">        <span class="op">(</span><span class="str">'_Secret'</span><span class="op">,</span><span class="str">'_-Secret'</span><span class="op">,</span> <span class="str">'self["Length"]'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t249" class="pln">        <span class="op">(</span><span class="str">'Secret'</span><span class="op">,</span> <span class="str">':'</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t250" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t251" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t252" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t253" class="stm run hide_run"><span class="key">def</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t254" class="pln">    <span class="com"># Section 5.1.3</span><span class="strut">&nbsp;</span></p>
<p id="t255" class="stm run hide_run">    <span class="nam">OutputKey</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t256" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">0</span><span class="op">:</span><span class="num">1</span><span class="op">]</span><span class="op">)</span> <span class="op">>></span> <span class="num">0x01</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t257" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">0</span><span class="op">:</span><span class="num">1</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x01</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">6</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">1</span><span class="op">:</span><span class="num">2</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">2</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t258" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">1</span><span class="op">:</span><span class="num">2</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x03</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">5</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">2</span><span class="op">:</span><span class="num">3</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">3</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t259" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">2</span><span class="op">:</span><span class="num">3</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x07</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">4</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">3</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">4</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t260" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">3</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x0F</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">3</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">4</span><span class="op">:</span><span class="num">5</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">5</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t261" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">4</span><span class="op">:</span><span class="num">5</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x1F</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">2</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">5</span><span class="op">:</span><span class="num">6</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">6</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t262" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">5</span><span class="op">:</span><span class="num">6</span><span class="op">]</span><span class="op">)</span><span class="op">&amp;</span><span class="num">0x3F</span><span class="op">)</span><span class="op">&lt;&lt;</span><span class="num">1</span><span class="op">)</span> <span class="op">|</span> <span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">6</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="op">)</span><span class="op">>></span><span class="num">7</span><span class="op">)</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t263" class="stm run hide_run">    <span class="nam">OutputKey</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span> <span class="nam">chr</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">InputKey</span><span class="op">[</span><span class="num">6</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0x7F</span><span class="op">)</span> <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t264" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t265" class="stm run hide_run">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">8</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t266" class="stm run hide_run">        <span class="nam">OutputKey</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span> <span class="op">=</span> <span class="nam">chr</span><span class="op">(</span><span class="op">(</span><span class="nam">ord</span><span class="op">(</span><span class="nam">OutputKey</span><span class="op">[</span><span class="nam">i</span><span class="op">]</span><span class="op">)</span> <span class="op">&lt;&lt;</span> <span class="num">1</span><span class="op">)</span> <span class="op">&amp;</span> <span class="num">0xfe</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t267" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t268" class="stm run hide_run">    <span class="key">return</span> <span class="nam">b</span><span class="op">(</span><span class="str">""</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">OutputKey</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t269" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t270" class="stm run hide_run"><span class="key">def</span> <span class="nam">decryptSecret</span><span class="op">(</span><span class="nam">key</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t271" class="pln">    <span class="com"># [MS-LSAD] Section 5.1.2</span><span class="strut">&nbsp;</span></p>
<p id="t272" class="stm mis">    <span class="nam">plainText</span> <span class="op">=</span> <span class="str">b''</span><span class="strut">&nbsp;</span></p>
<p id="t273" class="stm mis">    <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key</span><span class="strut">&nbsp;</span></p>
<p id="t274" class="stm mis">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">0</span><span class="op">,</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value</span><span class="op">)</span><span class="op">,</span> <span class="num">8</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t275" class="stm mis">        <span class="nam">cipherText</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t276" class="stm mis">        <span class="nam">tmpStrKey</span> <span class="op">=</span> <span class="nam">key0</span><span class="op">[</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t277" class="stm mis">        <span class="nam">tmpKey</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">tmpStrKey</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t278" class="stm mis">        <span class="nam">Crypt1</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">tmpKey</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t279" class="stm mis">        <span class="nam">plainText</span> <span class="op">+=</span> <span class="nam">Crypt1</span><span class="op">.</span><span class="nam">decrypt</span><span class="op">(</span><span class="nam">cipherText</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t280" class="stm mis">        <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key0</span><span class="op">[</span><span class="num">7</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t281" class="stm mis">        <span class="nam">value</span> <span class="op">=</span> <span class="nam">value</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t282" class="pln">        <span class="com"># AdvanceKey</span><span class="strut">&nbsp;</span></p>
<p id="t283" class="stm mis">        <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">key0</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">7</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t284" class="stm mis">            <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">key0</span><span class="op">)</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t285" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t286" class="stm mis">    <span class="nam">secret</span> <span class="op">=</span> <span class="nam">LSA_SECRET_XP</span><span class="op">(</span><span class="nam">plainText</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t287" class="stm mis">    <span class="key">return</span> <span class="op">(</span><span class="nam">secret</span><span class="op">[</span><span class="str">'Secret'</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t288" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t289" class="stm run hide_run"><span class="key">def</span> <span class="nam">encryptSecret</span><span class="op">(</span><span class="nam">key</span><span class="op">,</span> <span class="nam">value</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t290" class="pln">    <span class="com"># [MS-LSAD] Section 5.1.2</span><span class="strut">&nbsp;</span></p>
<p id="t291" class="stm run hide_run">    <span class="nam">cipherText</span> <span class="op">=</span> <span class="str">b''</span><span class="strut">&nbsp;</span></p>
<p id="t292" class="stm run hide_run">    <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key</span><span class="strut">&nbsp;</span></p>
<p id="t293" class="stm run hide_run">    <span class="nam">value0</span> <span class="op">=</span> <span class="nam">pack</span><span class="op">(</span><span class="str">'&lt;LL'</span><span class="op">,</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value</span><span class="op">)</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span> <span class="op">+</span> <span class="nam">value</span><span class="strut">&nbsp;</span></p>
<p id="t294" class="stm run hide_run">    <span class="key">for</span> <span class="nam">i</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="num">0</span><span class="op">,</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value0</span><span class="op">)</span><span class="op">,</span> <span class="num">8</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t295" class="stm run hide_run">        <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">value0</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">8</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t296" class="stm run hide_run">            <span class="nam">value0</span> <span class="op">=</span> <span class="nam">value0</span> <span class="op">+</span> <span class="str">b'\x00'</span><span class="op">*</span><span class="op">(</span><span class="num">8</span><span class="op">-</span><span class="nam">len</span><span class="op">(</span><span class="nam">value0</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t297" class="stm run hide_run">        <span class="nam">plainText</span> <span class="op">=</span> <span class="nam">value0</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t298" class="stm run hide_run">        <span class="nam">tmpStrKey</span> <span class="op">=</span> <span class="nam">key0</span><span class="op">[</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t299" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="nam">type</span><span class="op">(</span><span class="nam">tmpStrKey</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t300" class="stm run hide_run">        <span class="nam">print</span><span class="op">(</span><span class="nam">tmpStrKey</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t301" class="stm run hide_run">        <span class="nam">tmpKey</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">tmpStrKey</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t302" class="stm run hide_run">        <span class="nam">Crypt1</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">tmpKey</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t303" class="stm run hide_run">        <span class="nam">cipherText</span> <span class="op">+=</span> <span class="nam">Crypt1</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">plainText</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t304" class="stm run hide_run">        <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key0</span><span class="op">[</span><span class="num">7</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t305" class="stm run hide_run">        <span class="nam">value0</span> <span class="op">=</span> <span class="nam">value0</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t306" class="pln">        <span class="com"># AdvanceKey</span><span class="strut">&nbsp;</span></p>
<p id="t307" class="stm run hide_run">        <span class="key">if</span> <span class="nam">len</span><span class="op">(</span><span class="nam">key0</span><span class="op">)</span> <span class="op">&lt;</span> <span class="num">7</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t308" class="stm run hide_run">            <span class="nam">key0</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="nam">len</span><span class="op">(</span><span class="nam">key0</span><span class="op">)</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t309" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t310" class="stm run hide_run">    <span class="key">return</span> <span class="nam">cipherText</span><span class="strut">&nbsp;</span></p>
<p id="t311" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t312" class="stm run hide_run"><span class="key">def</span> <span class="nam">SamDecryptNTLMHash</span><span class="op">(</span><span class="nam">encryptedHash</span><span class="op">,</span> <span class="nam">key</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t313" class="pln">    <span class="com"># [MS-SAMR] Section 2.2.11.1.1</span><span class="strut">&nbsp;</span></p>
<p id="t314" class="stm mis">    <span class="nam">Block1</span> <span class="op">=</span> <span class="nam">encryptedHash</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t315" class="stm mis">    <span class="nam">Block2</span> <span class="op">=</span> <span class="nam">encryptedHash</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t316" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t317" class="stm mis">    <span class="nam">Key1</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t318" class="stm mis">    <span class="nam">Key1</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">Key1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t319" class="stm mis">    <span class="nam">Key2</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="num">7</span><span class="op">:</span><span class="num">14</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t320" class="stm mis">    <span class="nam">Key2</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">Key2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t321" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t322" class="stm mis">    <span class="nam">Crypt1</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Key1</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t323" class="stm mis">    <span class="nam">Crypt2</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Key2</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t324" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t325" class="stm mis">    <span class="nam">plain1</span> <span class="op">=</span> <span class="nam">Crypt1</span><span class="op">.</span><span class="nam">decrypt</span><span class="op">(</span><span class="nam">Block1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t326" class="stm mis">    <span class="nam">plain2</span> <span class="op">=</span> <span class="nam">Crypt2</span><span class="op">.</span><span class="nam">decrypt</span><span class="op">(</span><span class="nam">Block2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t327" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t328" class="stm mis">    <span class="key">return</span> <span class="nam">plain1</span> <span class="op">+</span> <span class="nam">plain2</span><span class="strut">&nbsp;</span></p>
<p id="t329" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t330" class="stm run hide_run"><span class="key">def</span> <span class="nam">SamEncryptNTLMHash</span><span class="op">(</span><span class="nam">encryptedHash</span><span class="op">,</span> <span class="nam">key</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t331" class="pln">    <span class="com"># [MS-SAMR] Section 2.2.11.1.1</span><span class="strut">&nbsp;</span></p>
<p id="t332" class="stm run hide_run">    <span class="nam">Block1</span> <span class="op">=</span> <span class="nam">encryptedHash</span><span class="op">[</span><span class="op">:</span><span class="num">8</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t333" class="stm run hide_run">    <span class="nam">Block2</span> <span class="op">=</span> <span class="nam">encryptedHash</span><span class="op">[</span><span class="num">8</span><span class="op">:</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t334" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t335" class="stm run hide_run">    <span class="nam">Key1</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="op">:</span><span class="num">7</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t336" class="stm run hide_run">    <span class="nam">Key1</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">Key1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t337" class="stm run hide_run">    <span class="nam">Key2</span> <span class="op">=</span> <span class="nam">key</span><span class="op">[</span><span class="num">7</span><span class="op">:</span><span class="num">14</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t338" class="stm run hide_run">    <span class="nam">Key2</span> <span class="op">=</span> <span class="nam">transformKey</span><span class="op">(</span><span class="nam">Key2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t339" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t340" class="stm run hide_run">    <span class="nam">Crypt1</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Key1</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t341" class="stm run hide_run">    <span class="nam">Crypt2</span> <span class="op">=</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">new</span><span class="op">(</span><span class="nam">Key2</span><span class="op">,</span> <span class="nam">DES</span><span class="op">.</span><span class="nam">MODE_ECB</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t342" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t343" class="stm run hide_run">    <span class="nam">plain1</span> <span class="op">=</span> <span class="nam">Crypt1</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">Block1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t344" class="stm run hide_run">    <span class="nam">plain2</span> <span class="op">=</span> <span class="nam">Crypt2</span><span class="op">.</span><span class="nam">encrypt</span><span class="op">(</span><span class="nam">Block2</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t345" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t346" class="stm run hide_run">    <span class="key">return</span> <span class="nam">plain1</span> <span class="op">+</span> <span class="nam">plain2</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
